defining, raising and catching exceptions

Chris Hare chare at labr.net
Fri Aug 6 00:41:36 CEST 2010


I have a block of test code, where I am trying to raise and catch my own user defined exception

class NetActiveError(RuntimeError):
    def __init__(self,error):
        self.args = error

def a():
    try:
        fh = open("me.txt", "r")
    except Exception as (errno, errText):
        print errText
    try:
        b()
    except NetActiveError as (errono, errText):
        print errno, errText

def b():
    print "def b"
    raise NetActiveError,"net already running"


a()


When I run it though, I get the following error:

chare$ python z
No such file or directory
def b
Traceback (most recent call last):
  File "z", line 20, in <module>
    a()
  File "z", line 12, in a
    except NetActiveError as (errono, errText):
ValueError: too many values to unpack


What am I doing wrong here?





More information about the Python-list mailing list